'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.GutterWidthContext = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _config = require('../../config');

var _style = require('./style');

var _style2 = _interopRequireDefault(_style);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var GutterWidthContext = exports.GutterWidthContext = _react2.default.createContext(false);

var Row = function (_React$PureComponent) {
  _inherits(Row, _React$PureComponent);

  function Row(props) {
    _classCallCheck(this, Row);

    var _this = _possibleConstructorReturn(this, (Row.__proto__ || Object.getPrototypeOf(Row)).call(this, props));

    _initialiseProps.call(_this);

    var as = props.as,
        component = props.component;

    var Component = as || component || 'div';

    var _getConfiguration = (0, _config.getConfiguration)(),
        componentDecorator = _getConfiguration.componentDecorator;

    _this.decoratedComponent = componentDecorator(Component, _this);
    return _this;
  }

  return Row;
}(_react2.default.PureComponent);

Row.displayName = 'Row';
Row.propTypes = {
  /**
   * Content of the element
   */
  children: _propTypes2.default.node.isRequired,
  /**
   * Vertical column alignment
   */
  align: _propTypes2.default.oneOf(['normal', 'start', 'center', 'end', 'stretch']),
  /**
   * Horizontal column alignment
   */
  justify: _propTypes2.default.oneOf(['start', 'center', 'end', 'between', 'around', 'initial', 'inherit']),
  /**
   * No gutter for this row
   */
  nogutter: _propTypes2.default.bool,
  /**
   * Custom gutter width for this row
   */
  gutterWidth: _propTypes2.default.number,
  /**
   * Optional styling
   */
  style: _propTypes2.default.objectOf(_propTypes2.default.oneOfType([_propTypes2.default.number, _propTypes2.default.string])),
  /**
   * Set to apply some debug styling
   */
  debug: _propTypes2.default.bool,
  /**
  * Use your own component
  */
  as: _propTypes2.default.elementType,
  /**
  * Alias of "as" prop
  */
  component: _propTypes2.default.elementType,
  /**
   * Whether the cols should not wrap
   */
  nowrap: _propTypes2.default.bool
};
Row.defaultProps = {
  align: 'normal',
  justify: 'start',
  nogutter: false,
  gutterWidth: null,
  style: {},
  debug: false,
  as: null,
  component: null
};

var _initialiseProps = function _initialiseProps() {
  var _this2 = this;

  this.render = function () {
    var _props = _this2.props,
        children = _props.children,
        style = _props.style,
        align = _props.align,
        justify = _props.justify,
        debug = _props.debug,
        nogutter = _props.nogutter,
        gutterWidth = _props.gutterWidth,
        component = _props.component,
        nowrap = _props.nowrap,
        otherProps = _objectWithoutProperties(_props, ['children', 'style', 'align', 'justify', 'debug', 'nogutter', 'gutterWidth', 'component', 'nowrap']);

    var theGutterWidth = (0, _config.getConfiguration)().gutterWidth;
    if (nogutter) theGutterWidth = 0;
    if (typeof gutterWidth === 'number') theGutterWidth = gutterWidth;
    var theStyle = (0, _style2.default)({
      gutterWidth: theGutterWidth,
      align: align,
      justify: justify,
      debug: debug,
      moreStyle: style,
      nowrap: nowrap
    });
    return _react2.default.createElement(_this2.decoratedComponent, _extends({ style: theStyle }, otherProps), _react2.default.createElement(
      GutterWidthContext.Provider,
      { value: theGutterWidth },
      children
    ));
  };
};

exports.default = Row;